summaryrefslogtreecommitdiff
path: root/helpers/lh_chroot_localpackageslist
diff options
context:
space:
mode:
Diffstat (limited to 'helpers/lh_chroot_localpackageslist')
-rwxr-xr-xhelpers/lh_chroot_localpackageslist73
1 files changed, 73 insertions, 0 deletions
diff --git a/helpers/lh_chroot_localpackageslist b/helpers/lh_chroot_localpackageslist
new file mode 100755
index 0000000..a7313cb
--- /dev/null
+++ b/helpers/lh_chroot_localpackageslist
@@ -0,0 +1,73 @@
+#!/bin/sh
+
+# lh_chroot_localpackageslist(1) - install local packages into chroot
+
+set -e
+
+# Source common functions
+for FUNCTION in /usr/share/live-helper/functions/*.sh
+do
+ . ${FUNCTION}
+done
+
+# Reading configuration files
+Read_conffile config/common
+Read_conffile config/chroot
+Set_defaults
+
+# Requiring stage file
+Require_stagefile "${LIVE_ROOT}"/.stage/bootstrap
+
+# Checking stage file
+Check_stagefile "${LIVE_ROOT}"/.stage/chroot_localpackageslist
+
+# Checking lock file
+Check_lockfile "${LIVE_ROOT}"/.lock
+
+# Creating lock file
+Create_lockfile "${LIVE_ROOT}"/.lock
+
+if ls "${LIVE_ROOT}"/config/chroot_localpackageslist/* &> /dev/null
+then
+ # Restore old cache
+ if [ -d "${LIVE_ROOT}"/cache/chroot_localpackageslist ]
+ then
+ cp "${LIVE_ROOT}"/cache/chroot_localpackageslist/*.deb "${LIVE_CHROOT}"/var/cache/apt/archives
+ fi
+
+ for PACKAGESLIST in "${LIVE_ROOT}"/config/chroot_localpackageslist/*
+ do
+ # Copying package list
+ grep -v "^#" "${PACKAGESLIST}" > "${LIVE_CHROOT}"/root/"`basename ${PACKAGESLIST}`"
+
+ # Installing package list
+ case "${LH_APT}" in
+ apt)
+ Chroot "xargs --arg-file=/root/`basename ${PACKAGESLIST}` apt-get install --yes"
+ ;;
+
+ aptitude)
+ Chroot "xargs --arg-file=/root/`basename ${PACKAGESLIST}` aptitude install --assume-yes"
+ ;;
+ esac
+
+ # Removing package list
+ rm -f "${LIVE_CHROOT}"/root/"`basename ${PACKAGESLIST}`"
+ done
+
+ # Saving new cache
+ Chroot "apt-get autoclean"
+
+ if ls "${LIVE_CHROOT}"/var/cache/apt/archives/*.deb &> /dev/null
+ then
+ if [ ! -d "${LIVE_ROOT}"/cache/chroot_localpackageslist ]
+ then
+ mkdir -p "${LIVE_ROOT}"/cache/chroot_localpackageslist
+ fi
+
+ mv -f "${LIVE_CHROOT}"/var/cache/apt/archives/*.deb "${LIVE_ROOT}"/cache/chroot_localpackageslist
+ fi
+
+ # Creating stage file
+ Create_stagefile "${LIVE_ROOT}"/.stage/chroot_localpackageslist
+fi